SystemOrganization addCategory: #'Xtreams-SqueakTextConverter'!

!TextConverter methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/13/2010 20:52'!
streamingAsEncoder

	^self! !

XTEncoder subclass: #XTSqueakEncoder
	instanceVariableNames: 'encoder skipRecord backupRecord'
	classVariableNames: 'TextConverterMap'
	poolDictionaries: ''
	category: 'Xtreams-SqueakTextConverter'!

!XTSqueakEncoder class methodsFor: 'instance creation' stamp: 'nice 10/12/2010 00:11'!
for: anEncoding

	^self new encoding: anEncoding! !

!XTSqueakEncoder class methodsFor: 'class initialization' stamp: 'nice 10/13/2010 20:45'!
initialize

	DialectEncoder := self.
	TextConverterMap := IdentityDictionary new.
	TextConverter withAllSubclassesDo: [:converterClass |
		converterClass encodingNames do: [:name |
			TextConverterMap at: name asSymbol put: converterClass]].! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/12/2010 00:21'!
decodeFrom: aReadStream

	^encoder nextFromStream: aReadStream! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/12/2010 00:21'!
encode: aCharacter on: aWriteStream

	^encoder nextPut: aCharacter toStream: aWriteStream! !

!XTSqueakEncoder methodsFor: 'accessing' stamp: 'nice 10/13/2010 20:19'!
encoding: anEncoding

	encoder := (TextConverterMap at: anEncoding) new.
	(encoder isKindOf: UTF16TextConverter) ifTrue: [ encoder useLittleEndian: false ]! !

!XTWriteStream methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/12/2010 00:44'!
basicNextPut: aCharacter
	"This has to be tricky: Squeak TextConverter will encode a Character into Character rather than anInteger..."
	self put: aCharacter asciiValue .
	^aCharacter! !

!XTWriteStream methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/12/2010 00:39'!
isBinary
	"This has to be tricky because Squeak TextConverter is a mess...
	Pretend we are not binary, otherwise TextConverter would attempt writing the Character verbatim..." 
	^false! !

!XTWriteStream methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/12/2010 00:44'!
nextPutAll: aString
	self write: aString.
	^aString! !

!XTReadStream methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/12/2010 00:42'!
basicNext
	"This has to be tricky: a Squeak TextConverter decodes a Character rather than an Integer...
	So let's feed him with a Character."
	^Character value: self get! !

!XTReadStream methodsFor: '*Xtreams-SqueakTextConverter' stamp: 'nice 10/12/2010 00:43'!
isBinary
	"This has to be tricky because Squeak TextConverter is a mess...
	Pretend we are not binary, otherwise TextConverter would attempt writing the Character verbatim..." 
	^false! !
XTSqueakEncoder initialize!
